#!/usr/bin/perl -w
use strict; 

# make sure the DADA lib is int he lib paths!
use lib qw(./ ./DADA ../ ../DADA ./DADA/perllib ../DADA/perllib); 

# use some of those Modules
use DADA::Config;
use DADA::Template::HTML; 
use DADA::App::Guts;
use DADA::MailingList::Settings; 

# we need this for cookies things
use CGI; 
my $q = new CGI; 


# This will take care of all our security woes
my ($admin_list, $root_login) = check_list_security(-cgi_obj  => $q,  
									                -Function => 'view_list_settings');

my $list = $admin_list; 

# get the list information
my $ls = DADA::MailingList::Settings->new(-List => $list); 
my $li = $ls->get; 
                              
# header     
print(admin_html_header(-Title      => "View List Settings",
		                -List       => $li->{list},
		                -Form       => 0,
		                -Root_Login => $root_login));

#
#
#
#	               
eval require HTML::Entities; 

if(!$@){ 
	foreach(sort keys %$li){ 
		print $q->p($q->b($_)); 
		print $q->hr; 
		my $e_settings = HTML::Entities::encode_entities($li->{$_}, "\200-\377");
		   $e_settings =~ s/>/\&gt;/g;
		   $e_settings =~ s/</\&lt;/g;	
		#special case
		if($_ eq 'admin_menu'){ 
			$e_settings =~ s/;/;\n/g;
		}
			
		print $q->pre($e_settings);
		print $q->hr;
	}
}else{ 
	print $q->p($q->b('I need the HTML::Entities module installed for this plugin to work!')); 
}

#
#
#
#



#footer
print admin_html_footer(-List => $list, -Form => 0); 


__END__

=pod

=head1 View List Settings 

This plugin allows you to view what ALL your list settings are set to

=head2  $ADMIN_MENU ENTRY

	 {-Title      => 'View List Settings', 
	  -Title_URL  => "plugins/view_list_settings.cgi",
	  -Function   => 'view_list_settings',
	  -Activated  => 1, 
	  },
  
=cut


