#!/usr/bin/env python
"""Distutils setup file"""
import sys, ez_setup
ez_setup.use_setuptools()
from setuptools import setup

# Metadata
PACKAGE_NAME = "FreeSwytch"
PACKAGE_VERSION = "0.1"
PACKAGES = ['freeswytch']
def get_description():
    # Get our long description from the documentation
    f = file('README.txt')
    lines = []
    for line in f:
        if not line.strip():
            break     # skip to first blank line
    for line in f:
        if line.startswith('.. contents::'):
            break     # read to table of contents
        lines.append(line)
    f.close()
    return ''.join(lines)

setup(
    name=PACKAGE_NAME,
    version=PACKAGE_VERSION,
    url = "http://pypi.python.org/pypi/FreeSwytch",
    description='Monitor/control VoIP/conferences using Trellis and FreeSWITCH'
                ' (w/optional Twisted support)',
    long_description = get_description(),
    author="Phillip J. Eby",
    author_email="peak@eby-sarna.com",
    license="PSF or ZPL",
    test_suite = 'test_fs',
    packages = PACKAGES,
    install_requires = ['Trellis>=0.6a1'],
    entry_points = {'console_scripts':
        'dump_switch_events = freeswytch.cli:DumpClient'}
)
